diff --git a/_ide_helper.php b/_ide_helper.php
index 9a3bc91..e29078a 100644
--- a/_ide_helper.php
+++ b/_ide_helper.php
@@ -23517,8 +25225,9 @@ namespace  {
              * @static 
              */ 
             public static function sharedLock()
-            {    
-                return \Illuminate\Database\Query\Builder::sharedLock();
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->sharedLock();
             }
          
             /**
@@ -23528,8 +25237,9 @@ namespace  {
              * @static 
              */ 
             public static function toSql()
-            {    
-                return \Illuminate\Database\Query\Builder::toSql();
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->toSql();
             }
          
             /**
@@ -23540,8 +25250,9 @@ namespace  {
              * @static 
              */ 
             public static function getCountForPagination($columns = array())
-            {    
-                return \Illuminate\Database\Query\Builder::getCountForPagination($columns);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->getCountForPagination($columns);
             }
          
             /**
@@ -23553,8 +25264,9 @@ namespace  {
              * @static 
              */ 
             public static function implode($column, $glue = '')
-            {    
-                return \Illuminate\Database\Query\Builder::implode($column, $glue);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->implode($column, $glue);
             }
          
             /**
@@ -23564,8 +25276,9 @@ namespace  {
              * @static 
              */ 
             public static function exists()
-            {    
-                return \Illuminate\Database\Query\Builder::exists();
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->exists();
             }
          
             /**
@@ -23575,8 +25288,9 @@ namespace  {
              * @static 
              */ 
             public static function doesntExist()
-            {    
-                return \Illuminate\Database\Query\Builder::doesntExist();
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->doesntExist();
             }
          
             /**
@@ -23587,8 +25301,9 @@ namespace  {
              * @static 
              */ 
             public static function count($columns = '*')
-            {    
-                return \Illuminate\Database\Query\Builder::count($columns);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->count($columns);
             }
          
             /**
@@ -23599,8 +25314,9 @@ namespace  {
              * @static 
              */ 
             public static function min($column)
-            {    
-                return \Illuminate\Database\Query\Builder::min($column);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->min($column);
             }
          
             /**
@@ -23611,8 +25327,9 @@ namespace  {
              * @static 
              */ 
             public static function max($column)
-            {    
-                return \Illuminate\Database\Query\Builder::max($column);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->max($column);
             }
          
             /**
@@ -23623,8 +25340,9 @@ namespace  {
              * @static 
              */ 
             public static function sum($column)
-            {    
-                return \Illuminate\Database\Query\Builder::sum($column);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->sum($column);
             }
          
             /**
@@ -23635,8 +25353,9 @@ namespace  {
              * @static 
              */ 
             public static function avg($column)
-            {    
-                return \Illuminate\Database\Query\Builder::avg($column);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->avg($column);
             }
          
             /**
@@ -23647,8 +25366,9 @@ namespace  {
              * @static 
              */ 
             public static function average($column)
-            {    
-                return \Illuminate\Database\Query\Builder::average($column);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->average($column);
             }
          
             /**
@@ -23660,8 +25380,9 @@ namespace  {
              * @static 
              */ 
             public static function aggregate($function, $columns = array())
-            {    
-                return \Illuminate\Database\Query\Builder::aggregate($function, $columns);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->aggregate($function, $columns);
             }
          
             /**
@@ -23673,8 +25394,9 @@ namespace  {
              * @static 
              */ 
             public static function numericAggregate($function, $columns = array())
-            {    
-                return \Illuminate\Database\Query\Builder::numericAggregate($function, $columns);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->numericAggregate($function, $columns);
             }
          
             /**
@@ -23685,8 +25407,9 @@ namespace  {
              * @static 
              */ 
             public static function insert($values)
-            {    
-                return \Illuminate\Database\Query\Builder::insert($values);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->insert($values);
             }
          
             /**
@@ -23698,8 +25421,23 @@ namespace  {
              * @static 
              */ 
             public static function insertGetId($values, $sequence = null)
-            {    
-                return \Illuminate\Database\Query\Builder::insertGetId($values, $sequence);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->insertGetId($values, $sequence);
+            }
+         
+            /**
+             * Insert new records into the table using a subquery.
+             *
+             * @param array $columns
+             * @param \Closure|\Illuminate\Database\Query\Builder|string $query
+             * @return bool 
+             * @static 
+             */ 
+            public static function insertUsing($columns, $query)
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->insertUsing($columns, $query);
             }
          
             /**
@@ -23711,8 +25449,9 @@ namespace  {
              * @static 
              */ 
             public static function updateOrInsert($attributes, $values = array())
-            {    
-                return \Illuminate\Database\Query\Builder::updateOrInsert($attributes, $values);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->updateOrInsert($attributes, $values);
             }
          
             /**
@@ -23722,8 +25461,9 @@ namespace  {
              * @static 
              */ 
             public static function truncate()
-            {    
-                \Illuminate\Database\Query\Builder::truncate();
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                $instance->truncate();
             }
          
             /**
@@ -23734,8 +25474,9 @@ namespace  {
              * @static 
              */ 
             public static function raw($value)
-            {    
-                return \Illuminate\Database\Query\Builder::raw($value);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->raw($value);
             }
          
             /**
@@ -23745,8 +25486,9 @@ namespace  {
              * @static 
              */ 
             public static function getBindings()
-            {    
-                return \Illuminate\Database\Query\Builder::getBindings();
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->getBindings();
             }
          
             /**
@@ -23756,8 +25498,9 @@ namespace  {
              * @static 
              */ 
             public static function getRawBindings()
-            {    
-                return \Illuminate\Database\Query\Builder::getRawBindings();
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->getRawBindings();
             }
          
             /**
@@ -23765,13 +25508,14 @@ namespace  {
              *
              * @param array $bindings
              * @param string $type
-             * @return $this 
+             * @return \Illuminate\Database\Query\Builder 
              * @throws \InvalidArgumentException
              * @static 
              */ 
             public static function setBindings($bindings, $type = 'where')
-            {    
-                return \Illuminate\Database\Query\Builder::setBindings($bindings, $type);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->setBindings($bindings, $type);
             }
          
             /**
@@ -23779,25 +25523,27 @@ namespace  {
              *
              * @param mixed $value
              * @param string $type
-             * @return $this 
+             * @return \Illuminate\Database\Query\Builder 
              * @throws \InvalidArgumentException
              * @static 
              */ 
             public static function addBinding($value, $type = 'where')
-            {    
-                return \Illuminate\Database\Query\Builder::addBinding($value, $type);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->addBinding($value, $type);
             }
          
             /**
              * Merge an array of bindings into our bindings.
              *
              * @param \Illuminate\Database\Query\Builder $query
-             * @return $this 
+             * @return \Illuminate\Database\Query\Builder 
              * @static 
              */ 
             public static function mergeBindings($query)
-            {    
-                return \Illuminate\Database\Query\Builder::mergeBindings($query);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->mergeBindings($query);
             }
          
             /**
@@ -23807,8 +25553,9 @@ namespace  {
              * @static 
              */ 
             public static function getProcessor()
-            {    
-                return \Illuminate\Database\Query\Builder::getProcessor();
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->getProcessor();
             }
          
             /**
@@ -23818,19 +25565,21 @@ namespace  {
              * @static 
              */ 
             public static function getGrammar()
-            {    
-                return \Illuminate\Database\Query\Builder::getGrammar();
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->getGrammar();
             }
          
             /**
              * Use the write pdo for query.
              *
-             * @return $this 
+             * @return \Illuminate\Database\Query\Builder 
              * @static 
              */ 
             public static function useWritePdo()
-            {    
-                return \Illuminate\Database\Query\Builder::useWritePdo();
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->useWritePdo();
             }
          
             /**
@@ -23841,8 +25590,9 @@ namespace  {
              * @static 
              */ 
             public static function cloneWithout($properties)
-            {    
-                return \Illuminate\Database\Query\Builder::cloneWithout($properties);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->cloneWithout($properties);
             }
          
             /**
@@ -23853,8 +25603,9 @@ namespace  {
              * @static 
              */ 
             public static function cloneWithoutBindings($except)
-            {    
-                return \Illuminate\Database\Query\Builder::cloneWithoutBindings($except);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->cloneWithoutBindings($except);
             }
          
             /**
@@ -23866,21 +25617,22 @@ namespace  {
              * @static 
              */ 
             public static function macro($name, $macro)
-            {    
-                \Illuminate\Database\Query\Builder::macro($name, $macro);
+            {
+                                \Illuminate\Database\Query\Builder::macro($name, $macro);
             }
          
             /**
              * Mix another object into the class.
              *
              * @param object $mixin
+             * @param bool $replace
              * @return void 
              * @throws \ReflectionException
              * @static 
              */ 
-            public static function mixin($mixin)
-            {    
-                \Illuminate\Database\Query\Builder::mixin($mixin);
+            public static function mixin($mixin, $replace = true)
+            {
+                                \Illuminate\Database\Query\Builder::mixin($mixin, $replace);
             }
          
             /**
@@ -23891,8 +25643,8 @@ namespace  {
              * @static 
              */ 
             public static function hasMacro($name)
-            {    
-                return \Illuminate\Database\Query\Builder::hasMacro($name);
+            {
+                                return \Illuminate\Database\Query\Builder::hasMacro($name);
             }
          
             /**
@@ -23905,8 +25657,9 @@ namespace  {
              * @static 
              */ 
             public static function macroCall($method, $parameters)
-            {    
-                return \Illuminate\Database\Query\Builder::macroCall($method, $parameters);
+            {
+                                /** @var \Illuminate\Database\Query\Builder $instance */
+                                return $instance->macroCall($method, $parameters);
             }
         }
 
diff --git a/app/Http/Controllers/Web/Auth/AuthController.php b/app/Http/Controllers/Web/Auth/AuthController.php
index 85b2346..719fedf 100644
--- a/app/Http/Controllers/Web/Auth/AuthController.php
+++ b/app/Http/Controllers/Web/Auth/AuthController.php
@@ -56,6 +56,7 @@ class AuthController extends Controller
      *
      * @param LoginRequest $request
      * @return \Illuminate\Http\RedirectResponse|\Illuminate\Http\Response|AuthController
+     * @throws \Illuminate\Contracts\Container\BindingResolutionException
      */
     public function postLogin(LoginRequest $request)
     {
@@ -210,14 +211,14 @@ class AuthController extends Controller
     /**
      * Increment the login attempts for the user.
      *
-     * @param  \Illuminate\Http\Request  $request
-     * @return int
+     * @param \Illuminate\Http\Request $request
+     * @return void
      */
     protected function incrementLoginAttempts(Request $request)
     {
         app(RateLimiter::class)->hit(
             $request->input($this->loginUsername()).$request->ip(),
-            $this->lockoutTime() / 60
+            $this->lockoutTime()
         );
     }
 
diff --git a/app/Http/Controllers/Web/PermissionsController.php b/app/Http/Controllers/Web/PermissionsController.php
index 50bc37c..45fd6dc 100644
--- a/app/Http/Controllers/Web/PermissionsController.php
+++ b/app/Http/Controllers/Web/PermissionsController.php
@@ -2,6 +2,7 @@
 
 namespace Portal\Http\Controllers\Web;
 
+use Illuminate\Support\Arr;
 use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
 use Portal\Events\Role\PermissionsUpdated;
 use Portal\Http\Controllers\Controller;
@@ -139,7 +140,7 @@ class PermissionsController extends Controller
         $allRoles = $this->roles->lists('id');
 
         foreach ($allRoles as $roleId) {
-            $permissions = array_get($roles, $roleId, []);
+            $permissions = Arr::get($roles, $roleId, []);
             $this->roles->updatePermissions($roleId, $permissions);
         }
 
diff --git a/app/Http/Controllers/Web/ProfileController.php b/app/Http/Controllers/Web/ProfileController.php
index 393a6b2..b319eaa 100644
--- a/app/Http/Controllers/Web/ProfileController.php
+++ b/app/Http/Controllers/Web/ProfileController.php
@@ -12,6 +12,7 @@ use Portal\Repositories\Country\CountryRepository;
 use Portal\Repositories\Role\RoleRepository;
 use Portal\Repositories\Session\SessionRepository;
 use Portal\Repositories\User\UserRepository;
+use Portal\Role;
 use Portal\Services\Upload\UserAvatarManager;
 use Portal\Support\Enum\UserStatus;
 use Portal\User;
@@ -60,17 +61,18 @@ class ProfileController extends Controller
      */
     public function index(RoleRepository $rolesRepo, CountryRepository $countryRepository)
     {
-        $user = $this->theUser;
-        $edit = true;
-        $roles = $rolesRepo->lists();
-        $countries = [0 => 'Select a Country'] + $countryRepository->lists()->toArray();
-        $socialLogins = $this->users->getUserSocialLogins($this->theUser->id);
-        $statuses = UserStatus::lists();
-
-        return view(
-            'user/profile',
-            compact('user', 'edit', 'roles', 'countries', 'socialLogins', 'statuses')
-        );
+        $roles = $rolesRepo->all()->filter(function ($role) {
+            return $role->id == $this->theUser->role_id;
+        })->pluck('name', 'id');
+
+        return view('user/profile', [
+            'user' => $this->theUser,
+            'edit' => true,
+            'roles' => $roles,
+            'countries' => [0 => 'Select a Country'] + $countryRepository->lists()->toArray(),
+            'socialLogins' => $this->users->getUserSocialLogins($this->theUser->id),
+            'statuses' => UserStatus::lists()
+        ]);
     }
 
     /**
diff --git a/app/Http/Controllers/Web/UsersController.php b/app/Http/Controllers/Web/UsersController.php
index 1aab6a7..d67943b 100644
--- a/app/Http/Controllers/Web/UsersController.php
+++ b/app/Http/Controllers/Web/UsersController.php
@@ -2,6 +2,7 @@
 
 namespace Portal\Http\Controllers\Web;
 
+use Illuminate\Support\Arr;
 use Portal\Events\User\Banned;
 use Portal\Events\User\Deleted;
 use Portal\Events\User\UpdatedByAdmin;
@@ -116,7 +117,7 @@ class UsersController extends Controller
         // status to Active by default.
         $data = $request->all() + ['status' => UserStatus::ACTIVE];
 
-        if (! array_get($data, 'country_id')) {
+        if (! Arr::get($data, 'country_id')) {
             $data['country_id'] = null;
         }
 
@@ -165,7 +166,7 @@ class UsersController extends Controller
     {
         $data = $request->all();
 
-        if (! array_get($data, 'country_id')) {
+        if (! Arr::get($data, 'country_id')) {
             $data['country_id'] = null;
         }
 
diff --git a/app/Http/Requests/Auth/LoginRequest.php b/app/Http/Requests/Auth/LoginRequest.php
index f4279d6..360814e 100644
--- a/app/Http/Requests/Auth/LoginRequest.php
+++ b/app/Http/Requests/Auth/LoginRequest.php
@@ -24,6 +24,7 @@ class LoginRequest extends Request
      * Get the needed authorization credentials from the request.
      *
      * @return array
+     * @throws \Illuminate\Contracts\Container\BindingResolutionException
      */
     public function getCredentials()
     {
@@ -48,6 +49,7 @@ class LoginRequest extends Request
      *
      * @param $param
      * @return bool
+     * @throws \Illuminate\Contracts\Container\BindingResolutionException
      */
     private function isEmail($param)
     {
diff --git a/app/Http/Requests/Auth/PasswordResetRequest.php b/app/Http/Requests/Auth/PasswordResetRequest.php
index 7a11b16..5798284 100644
--- a/app/Http/Requests/Auth/PasswordResetRequest.php
+++ b/app/Http/Requests/Auth/PasswordResetRequest.php
@@ -16,7 +16,7 @@ class PasswordResetRequest extends Request
         return [
             'token' => 'required',
             'email' => 'required|email',
-            'password' => 'required|confirmed|min:6'
+            'password' => 'required|confirmed|min:8'
         ];
     }
 }
diff --git a/app/Http/Requests/Auth/RegisterRequest.php b/app/Http/Requests/Auth/RegisterRequest.php
index 731d8e5..135e427 100644
--- a/app/Http/Requests/Auth/RegisterRequest.php
+++ b/app/Http/Requests/Auth/RegisterRequest.php
@@ -16,7 +16,7 @@ class RegisterRequest extends Request
         $rules = [
             'email' => 'required|email|unique:users,email',
             'username' => 'required|unique:users,username',
-            'password' => 'required|confirmed|min:6',
+            'password' => 'required|confirmed|min:8',
         ];
 
         if (settings('registration.captcha.enabled')) {
diff --git a/app/Http/Requests/BinaryFileUploadRequest.php b/app/Http/Requests/BinaryFileUploadRequest.php
index 86ee243..6c4ad91 100644
--- a/app/Http/Requests/BinaryFileUploadRequest.php
+++ b/app/Http/Requests/BinaryFileUploadRequest.php
@@ -5,6 +5,7 @@ namespace Portal\Http\Requests;
 use Illuminate\Contracts\Filesystem\Filesystem;
 use Illuminate\Http\UploadedFile;
 use Illuminate\Contracts\Validation\Validator;
+use Illuminate\Support\Str;
 
 abstract class BinaryFileUploadRequest extends Request
 {
@@ -47,9 +48,7 @@ abstract class BinaryFileUploadRequest extends Request
      */
     protected function getUploadedFile()
     {
-        $this->fileName = str_random(20);
-
-
+        $this->fileName = Str::random(20);
 
         $this->fs->put($this->fileName, $this->getContent());
 
diff --git a/app/Http/Requests/User/UpdateLoginDetailsRequest.php b/app/Http/Requests/User/UpdateLoginDetailsRequest.php
index 9eb4996..f46f149 100644
--- a/app/Http/Requests/User/UpdateLoginDetailsRequest.php
+++ b/app/Http/Requests/User/UpdateLoginDetailsRequest.php
@@ -19,7 +19,7 @@ class UpdateLoginDetailsRequest extends Request
         return [
             'email' => 'required|email|unique:users,email,' . $user->id,
             'username' => 'nullable|unique:users,username,' . $user->id,
-            'password' => 'nullable|min:6|confirmed'
+            'password' => 'nullable|min:8|confirmed'
         ];
     }
 
diff --git a/app/Listeners/Registration/SendConfirmationEmail.php b/app/Listeners/Registration/SendConfirmationEmail.php
index b1674f3..cdcbe45 100644
--- a/app/Listeners/Registration/SendConfirmationEmail.php
+++ b/app/Listeners/Registration/SendConfirmationEmail.php
@@ -2,6 +2,7 @@
 
 namespace Portal\Listeners\Registration;
 
+use Illuminate\Support\Str;
 use Portal\Events\User\Registered;
 use Portal\Notifications\EmailConfirmation;
 use Portal\Repositories\User\UserRepository;
@@ -32,7 +33,7 @@ class SendConfirmationEmail
 
         $user = $event->getRegisteredUser();
 
-        $token = str_random(60);
+        $token = Str::random(60);
         $this->users->update($user->id, [
             'confirmation_token' => $token
         ]);
diff --git a/app/Repositories/Role/EloquentRole.php b/app/Repositories/Role/EloquentRole.php
index 88b15d7..ac9da82 100644
--- a/app/Repositories/Role/EloquentRole.php
+++ b/app/Repositories/Role/EloquentRole.php
@@ -6,8 +6,6 @@ use Portal\Events\Role\Created;
 use Portal\Events\Role\Deleted;
 use Portal\Events\Role\Updated;
 use Portal\Role;
-use Portal\Support\Authorization\CacheFlusherTrait;
-use DB;
 
 class EloquentRole implements RoleRepository
 {
diff --git a/app/Services/Auth/Api/TokenFactory.php b/app/Services/Auth/Api/TokenFactory.php
index 2306323..35b2122 100644
--- a/app/Services/Auth/Api/TokenFactory.php
+++ b/app/Services/Auth/Api/TokenFactory.php
@@ -4,6 +4,7 @@ namespace Portal\Services\Auth\Api;
 
 use Carbon\Carbon;
 use Illuminate\Http\Request;
+use Illuminate\Support\Str;
 use Portal\User;
 use Illuminate\Contracts\Config\Repository as ConfigContract;
 
@@ -40,7 +41,7 @@ class TokenFactory
         $ttl = $this->config->get('jwt.ttl');
 
         $token = (new Token)->forceFill([
-            'id' => str_random(40),
+            'id' => Str::random(40),
             'user_id' => $user->id,
             'ip_address' => $this->request->ip(),
             'user_agent' => $this->getUserAgent(),
diff --git a/app/Services/Auth/Social/SocialManager.php b/app/Services/Auth/Social/SocialManager.php
index e5c88b2..bf3d80c 100644
--- a/app/Services/Auth/Social/SocialManager.php
+++ b/app/Services/Auth/Social/SocialManager.php
@@ -2,6 +2,7 @@
 
 namespace Portal\Services\Auth\Social;
 
+use Illuminate\Support\Str;
 use Laravel\Socialite\Contracts\User as SocialUser;
 use Portal\Repositories\Role\RoleRepository;
 use Portal\Repositories\User\UserRepository;
@@ -53,7 +54,7 @@ class SocialManager
 
             $user = $this->users->create([
                 'email' => $socialUser->getEmail(),
-                'password' => str_random(10),
+                'password' => Str::random(10),
                 'first_name' => $firstName,
                 'last_name' => $lastName,
                 'status' => UserStatus::ACTIVE,
diff --git a/app/Services/Upload/UserAvatarManager.php b/app/Services/Upload/UserAvatarManager.php
index 7bc2c23..f5eda59 100644
--- a/app/Services/Upload/UserAvatarManager.php
+++ b/app/Services/Upload/UserAvatarManager.php
@@ -3,6 +3,7 @@
 namespace Portal\Services\Upload;
 
 use Illuminate\Http\UploadedFile;
+use Illuminate\Support\Str;
 use Portal\User;
 use Illuminate\Filesystem\Filesystem;
 use Intervention\Image\ImageManager;
@@ -68,7 +69,7 @@ class UserAvatarManager
      */
     private function userHasUploadedAvatar(User $user)
     {
-        return $user->avatar && ! str_contains($user->avatar, ['http', 'gravatar']);
+        return $user->avatar && ! Str::contains($user->avatar, ['http', 'gravatar']);
     }
 
     /**
@@ -124,7 +125,7 @@ class UserAvatarManager
      */
     private function generateAvatarName()
     {
-        return sprintf("%s.png", str_random());
+        return sprintf("%s.png", Str::random());
     }
 
     /**
diff --git a/app/Support/Authorization/AuthorizationRoleTrait.php b/app/Support/Authorization/AuthorizationRoleTrait.php
index 2a21c91..7777f41 100644
--- a/app/Support/Authorization/AuthorizationRoleTrait.php
+++ b/app/Support/Authorization/AuthorizationRoleTrait.php
@@ -32,6 +32,7 @@ trait AuthorizationRoleTrait
     /**
      * Override "delete" role method to clear role cache.
      * @param array $options
+     * @throws \Exception
      */
     public function delete(array $options = [])
     {
@@ -177,7 +178,7 @@ trait AuthorizationRoleTrait
      */
     private function getCacheKey()
     {
-        return 'entrust_permissions_for_role_'.$this->{$this->primaryKey};
+        return 'permissions_for_role_'.$this->{$this->primaryKey};
     }
 
     /**
diff --git a/config/app.php b/config/app.php
index a039089..f039ecc 100644
--- a/config/app.php
+++ b/config/app.php
@@ -23,7 +23,7 @@ return [
     | Portal Version
     |--------------------------------------------------------------------------
     */
-    'version' => '3.1.0',
+    'version' => '3.2.0',
 
     /*
     |--------------------------------------------------------------------------
diff --git a/config/cache.php b/config/cache.php
index 42c26c2..cebc37b 100644
--- a/config/cache.php
+++ b/config/cache.php
@@ -2,7 +2,15 @@
 
 return [
 
-    'ttl' => 60,
+    /*
+    |--------------------------------------------------------------------------
+    | Default Cache TTL
+    |--------------------------------------------------------------------------
+    |
+    | Default cache TTL (in seconds) used for caching roles and permissions.
+    |
+    */
+    'ttl' => 3600,
 
     /*
     |--------------------------------------------------------------------------
diff --git a/database/factories/PermissionFactory.php b/database/factories/PermissionFactory.php
index d7c8ea3..e811b0b 100644
--- a/database/factories/PermissionFactory.php
+++ b/database/factories/PermissionFactory.php
@@ -1,10 +1,11 @@
 <?php
 
 use Faker\Generator as Faker;
+use Illuminate\Support\Str;
 
 $factory->define(Portal\Permission::class, function (Faker $faker) {
     return [
-        'name' => str_random(5),
+        'name' => Str::random(5),
         'display_name' => implode(" ", $faker->words(2)),
         'description' => substr($faker->paragraph, 0, 191),
         'removable' => true
diff --git a/database/factories/RoleFactory.php b/database/factories/RoleFactory.php
index d85f880..e5f5ba8 100644
--- a/database/factories/RoleFactory.php
+++ b/database/factories/RoleFactory.php
@@ -1,10 +1,11 @@
 <?php
 
 use Faker\Generator as Faker;
+use Illuminate\Support\Str;
 
 $factory->define(Portal\Role::class, function (Faker $faker) {
     return [
-        'name' => str_random(5),
+        'name' => Str::random(5),
         'display_name' => implode(" ", $faker->words(2)),
         'description' => substr($faker->paragraph, 0, 191),
         'removable' => true,
diff --git a/database/factories/TokenFactory.php b/database/factories/TokenFactory.php
index a22d85a..007c03c 100644
--- a/database/factories/TokenFactory.php
+++ b/database/factories/TokenFactory.php
@@ -1,10 +1,11 @@
 <?php
 
 use Faker\Generator as Faker;
+use Illuminate\Support\Str;
 
 $factory->define(\Portal\Services\Auth\Api\Token::class, function (Faker $faker) {
     return [
-        'id' => str_random(40),
+        'id' => Str::random(40),
         'user_id' => function () {
             return factory(\Portal\User::class)->create()->id;
         },
